package tool;

import javax.microedition.lcdui.*;
import java.util.*;
import parser.*;

public class Graph {
 int clBackground, clAxis, clGrid, clText, clOxy;
 int sizeOxy, sizeText, sizeLine, lineSpace;
 public boolean grid, axisVisible;
 public int ox, oy, op, count;
 int width, height, outx, outy, max;
 int intx1, inty1, intx, inty;
 double d, x, y, t;
 String sx, sy;
 double[] Temp;
 Graphics g;

 public Graph(Graphics g, int width, int height) {
  clBackground = 0;
  clAxis = 165317;
  clGrid = 16777215;
  clText = 16777215;
  clOxy = 65280;
  sizeOxy = 12;
  sizeText = 8;
  sizeLine = 3;
  lineSpace = 1;
  grid = true;
  axisVisible = true;
  this.width = width;
  this.height = height;
  this.g = g;
  ox = width / 2;
  oy = height / 2;
  op = 14;
  max = Locale.ScrWidth;
  Temp = new double[max];
 }

 private boolean check(int x, int y) {
  return (0<=x)&&(x<=width)&&(0<=y)&&(y<=height);
 }

 private void PointRealToForm(double inpx, double inpy)	{
  outx = (int) (ox + inpx * op);
  outy = (int) (oy - inpy * op);
 }

 private void lin(int x1, int y1, int x2, int y2) {
  int tt;
  g.setColor(clGrid);
  if (x1 == x2) {
   tt = oy % op;
   while (tt <= height)	{
    g.drawLine(x1, tt, x1, tt);
    tt += op;
   }
  }
  else {
   tt = ox % op;
   while (tt <= width) {
    g.drawLine(tt, y1, tt, y1);
    tt += op;
   }
  }
  g.setColor(clAxis);
 }

 public void DrawAxis()	{
  int x, y, k, t1;
  //Clear
  g.setColor(clBackground);
  g.fillRect(0, 0, width, height);
  if (!axisVisible) return;
  //Font
  g.setFont(Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_SMALL));
  //Axis 1
  if (op < 40) k = 40/op;
  else k = 1;
  x = ox - op; t1 = 0;
  while (x > 10) {
   t1--;
   if (grid)
    if (op >= 10) lin(x, 0, x, height);
   if (t1 % k ==0) {
    if (t1 % (k*lineSpace) == 0) {
     g.setColor(clText);
     g.drawString(String.valueOf(t1), x + 5, oy + 5, g.TOP | g.LEFT);
     g.setColor(clAxis);
    }
    g.drawLine(x, oy-sizeLine, x, oy+sizeLine);
   }
   x = x-op;
  }
  //Axis 2
  x = ox+op; t1 = 0;
  while (x<width) {
   t1++;
   if (grid)
    if (op >= 10) lin(x, 0, x, height);
   if (t1 % k == 0) {
    if (t1 % (k * lineSpace) == 0) {
     g.setColor(clText);
     g.drawString(String.valueOf(t1), x + 5, oy + 5, g.TOP|g.LEFT);
     g.setColor(clAxis);
     g.drawLine(x, oy - sizeLine, x, oy + sizeLine);
    }
   }
   x = x + op;
  }
  //Axis 3
  y = oy-op; t1 = 0;
  while (y>0) {
   t1++;
   if (grid)
    if (op>=10)lin(0,y,width,y);
   if (t1 % k==0) {
    if (ox > 5){
     g.drawLine(ox - sizeLine, y, ox + sizeLine, y);
    }
    else {
     g.drawLine(0, y, ox+sizeLine, y);
    }
    if (t1 % (k * lineSpace) == 0) {
     g.setColor(clText);
     g.drawString(String.valueOf(t1), ox + 10, y - 5, g.TOP | g.LEFT);
     g.setColor(clAxis);
    }
   }
   y -= op;
  }
  //Axis 4
  y = oy + op; t1 = 0;
  while (y < height) {
   t1--;
   if (grid)
    if (op>=10) lin(0,y,width,y);
   if (t1 % k==0) {
    if (ox > 5) {
     g.drawLine(ox - sizeLine, y, ox + sizeLine, y);
    }
    else {
     g.drawLine(0, y, ox + sizeLine, y);
    }
    if (t1 % (k * lineSpace) == 0) {
     g.setColor(clText);
     g.drawString(String.valueOf(t1), ox + 10, y - 5, g.TOP | g.LEFT);
     g.setColor(clAxis);
    }
   }
   y = y+op;
  }
  //Oxy
  g.setColor(clOxy);
  g.setFont(Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_BOLD, Font.SIZE_MEDIUM));
  g.drawString("y", ox+5, 0, g.TOP|g.LEFT);
  g.drawString("x", width-20, oy, g.TOP|g.LEFT);
  g.setColor(clAxis);
  g.drawLine(0, oy, width, oy);
  g.drawLine(ox, 0, ox, height);
  g.drawLine(width-sizeLine, oy-sizeLine, width, oy);
  g.drawLine(width-sizeLine, oy+sizeLine, width, oy);
  g.drawLine(ox-sizeLine, sizeLine, ox, 0);
  g.drawLine(ox+sizeLine, sizeLine, ox, 0);
 }

 public void DrawYX(String exp, double v1, double v2) {
  int i, k;
  exp = Utils.strDelSpc(exp).toUpperCase();
  exp = Utils.strReplace(exp, "Y=", "");
  //Build TempT,TempR
  if (v1 < -ox / op) v1 = -ox / op;
  if (v2 > (width - ox) / op) v2 = (width - ox) / op;
  count = (int) (v2 - v1) * op;
  if (count == 0)return;
  d = (v2 - v1) / count;
  //Evaluate
  Utils.prepareVal('X',exp);
  PointRealToForm(v1, Utils.Cal(v1));
  intx1 = outx; inty1=outy;

  for (i = 1; i < count; i++) {
   x = v1 + d * i;
   PointRealToForm(x, Utils.Cal(x));
   intx = outx; inty = outy;
   if (check(intx, inty) || check(intx1, inty1))
    if (Math.abs(inty - inty1) < height / 2)
     g.drawLine(intx1, inty1, intx, inty);
   intx1 = intx; inty1 = inty;
  }
 }

 public void DrawRT(String exp, double v1, double v2) {
  int  i, k;
  exp = Utils.strDelSpc(exp).toUpperCase();
  exp = Utils.strReplace(exp, "R=", "");
  //Build TempT,TempR
  v1 = (v1 * Math.PI / 180);
  v2 = (v2 * Math.PI / 180);
  count = max;
  d = ((v2 - v1) / count);
  //Draw
  Utils.prepareVal('T',exp);
  x = v1; y = Utils.Cal(x);
  PointRealToForm(y * Math.cos(x), y * Math.sin(x));
  intx1 = outx; inty1 = outy;
  for (i=1; i<count; i++) {
   x = v1 + d * i; y = Utils.Cal(x);
   PointRealToForm(y * Math.cos(x), y * Math.sin(x));
   intx = outx; inty = outy;
   if (check(intx, inty) || check(intx1, inty1))
    g.drawLine(intx1, inty1, intx, inty);
   intx1 = intx; inty1 = inty;
  }
 }

 public void DrawXY(String exp, double v1, double v2) {
  int  i, k;

  exp = Utils.strDelSpc(exp).toUpperCase();
  exp = Utils.strReplace(exp, "X=", "");
  //Build TempT,TempR
  if (v1 < -ox / op) v1 = -ox / op;
  if (v2 > (width - ox) / op) v2 = (width - ox) / op;
  count = (int) (v2 - v1) * op;
  if (count == 0)return;
  d = (v2 - v1) / count;
  //Evaluate
  Utils.prepareVal('Y',exp);
  PointRealToForm(Utils.Cal(v1), v1);
  intx1 = outx; inty1=outy;

  for (i = 1; i < count; i++) {
   y = v1 + d * i;
   PointRealToForm(Utils.Cal(y), y);
   intx = outx; inty = outy;
   if (check(intx, inty) || check(intx1, inty1))
    if (Math.abs(inty - inty1) < height / 2)
     g.drawLine(intx1, inty1, intx, inty);
   intx1 = intx; inty1 = inty;
  }
 }

 public void DrawYXT(String exp, double v1, double v2) {
  int  i, k, l;
  exp = Utils.strDelSpc(exp).toUpperCase();
  k = exp.indexOf("_");
  sx = exp.substring(0, k);
  sy = exp.substring(k+1, exp.length());
  sx = Utils.strReplace(sx, "XT=", "");
  sy = Utils.strReplace(sy, "YT=", "");
  count = max;
  d = (v2 - v1) / count;
  //Evaluate
  Utils.prepareVal('T', sx);
  for (i = 0; i < count; i++) {
   t = v1 + d * i;
   Temp[i] = Utils.Cal(t);
  }
  //Draw
  Utils.prepareVal('T',sy);
  t = v1;
  PointRealToForm(Temp[0], Utils.Cal(t));
  intx1 = outx; inty1 = outy;
  for (i=1; i<count; i++) {
   t = v1 + d * i;
   PointRealToForm(Temp[i], Utils.Cal(t));
   intx = outx; inty = outy;
   if (check(intx, inty) || check(intx1, inty1))
    if (Math.abs(inty - inty1) < height / 2)
     g.drawLine(intx1, inty1, intx, inty);
   intx1 = intx; inty1 = inty;
  }
 }

}